#include "pcmctrl.h"
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <math.h>
#include <string.h>
#include <unistd.h>

void errorQuit(char *s){
  fprintf(stderr, "顼: %s\n",s);
  exit(1);
}

/**
 * եƬ򤵤եݥ󥿤إåƼɤࡣ
 * ؿλǡȷǡΤƬ򤵤
 * @return 0: 0ʳ:۾
 * @param fp ľΥե(Ƭ)
 * @param fcMode 0:ǽ 1:ǽ(ѥפʤ)
 * @param sStart ():ȷǡϰ(Х)
 * @param fLength ():ե졼
 * @param sCh, sBits, sFreq ():̻ͥҲӥåȿץ󥰼ȿ
 */
int readWaveHeader(FILE *fp, int &sStart,
		   long long &fLength,
		   int &sCh, int &sBit, int &sFreq,
		   int fcMode){
  char s[256];
  unsigned int ui;
  unsigned short us;
  unsigned int uichunk;//chunkĹ(Х)
  int fUnit;           //ե졼ढΥХȿ
  int pos = 0;         //եΰ
  int l;
  long long lengthF=0;//եǿ𤵤줿Ĺ
  long long lengthR=0;//ե򥷡ʬäĹ
  
  //ǽ"RIFF"
  if(fread(s,4,1,fp)!=1)
    return -102;
  if(strncmp(s,"RIFF",4))
    return -103;
  
  //length_all
  if(fread(&ui,4,1,fp)!=1)
    return -104;

  //"WAVEfmt "
  if(fread(s,8,1,fp)!=1)
    return -105;
  if(strncmp(s,"WAVEfmt ",8))
    return -106;
  
  //chunkĹ
  if(fread(&uichunk,4,1,fp)!=1)
    return -107;
  
  //PCMɤ
  if(fread(&us,2,1,fp)!=1)
    return -108;
  if(us != 1)
    return -109;//PCMǡǤʤ
  
  //ϥͥ
  if(fread(&us,2,1,fp)!=1)
    return -110;
  sCh = us;
  
  //ϥץ󥰼ȿ
  if(fread(&ui,4,1,fp)!=1)
    return -111;
  sFreq = ui;  
  
  //1äΥХȿ
  if(fread(&ui,4,1,fp)!=1)
    return -112;
  
  //1ե졼ढΥХȿ
  if(fread(&us,2,1,fp)!=1)
    return -113;
  
  //ϥץ̻Ҳӥåȿ
  if(fread(&us,2,1,fp)!=1)
    return -114;
  sBit = us;
  if(sBit!=8 && sBit!=16)
    return -115;//бǤʤ̻Ҳӥåȿ
  
  fUnit = sCh * sBit / 8; //1ե졼ΥХȿ
  
  //chunkޤ
  for(l = 0;l < (int)(uichunk) - 16;l++){
    if(fread(s, 1,1, fp)!=1){
      return -4;//ɤ߼꼺
    }
  }
  pos = uichunk + 20;     //chunkμΰ
  
  /* "data"ޤɤ߹ */
  for(l=0;l<256;l++){
    //4Хɤ߼
    if(fread(s,4,1,fp)!=1)
      return -5;
    pos += 4;
    
    //'data'ä
    if(!strncmp(s,"data",4))
      break;
    //'fact'ä
    else if(!strncmp(s,"fact",4)){ 
      //8Хȿʤ
      if(fread(s,8,1,fp)!=1)
	return -5;
      pos += 8;
    }
    //'data'Ǥ'fact'Ǥʤ
    else {                   
      return -6; //ǡƤ۾
    }
  }
  if(l==256)
    return -119;//"data"Ĥʤä
  
  //ǡΤĹɤ߼
  if(fread(&ui,4,1,fp)!=1)
    return -7;
  lengthF = ui;
  pos += 4;//ȷǡƬؤ
  sStart = pos;
  
  switch(fcMode){
  case 0://ǽʥե
    //եĹǡĹ򻻽Ф
    fseeko(fp, 0, SEEK_END);
    lengthR = ftello(fp) - (long long)sStart;
    if((long long)(ftello(fp)) <= (long long)sStart)
      lengthR = 0;   //ȷǡʤ
    //ǡƬ˥
    fseeko(fp, sStart, SEEK_SET);
    //ե졼ϼºݤΥեĹ黻
    fLength = lengthR / fUnit;
    break;    
  case 1://ǽξ
    //ե졼ϡե˽񤭹ޤƤĹ黻
    fLength = lengthF / fUnit;
    break;
  default://ʥ⡼ɤʤΤĹ0
    fLength = 0;
    break;
  }
  return 0;
}

int main(int argc, char *argv[]){
  int optr;
  FILE *fp;
  int showMode = 1;         //0:ɽʤ 1:̾ɽ
  int fileMode = 0;         //0:̾Υե 1:ɸϤ
  int openMode = SND_PCM_NONBLOCK;//ǥեȤϥΥ֥å⡼
  int sampleStart = 0;      //ץǡγϰ
  long long frameLength = 0;//ǡĹե졼Ǹä
  long long framePos = 0;   //ߤΥե졼
  int ototobi = 0;          //İǤӤβ
  int r, wSize, r2;             //ɤ߽񤭼/ͽΥե졼
  snd_pcm_sframes_t freeSpace = 0;//줫񤭹ե졼
  snd_pcm_sframes_t bufSize = 0;//ºݤѲǽFIFOХåեΥե졼
  char * writeBuf;             //ϥХåե
  int endFlag = 0; //λѥե饰ΩƤȼΥǥХϸ˽λ
  int sCh=0, sBit=0, sFreq=0, frameUnit=0;//եޥåȴط
  PcmCTRL pcm; //ɥɥ饤дط
  int pretry;  //ȥ饤ѥ

  //ץν
  while((optr=getopt(argc, argv, "bsqhd:"))!=-1){
    switch(optr){
    case 'b'://֥å⡼
      openMode = 0;//0֥å⡼(ե饰ߤ)
      break;
    case 's'://ɸϥ⡼
      fp = stdin;
      fileMode = 1;
      break; 
    case 'q'://Ťʥ⡼
      showMode = 0;
      break;
    case 'd'://ǥХ̾
      if(optarg==NULL)
	errorQuit("ǥХ̾Ĥޤ");
      pcm.setDeviceName(optarg);
      break;
    case 'h'://ɽƽλ
    case '?':
    default:
      printf("Ȥ:\n-bϥ֥å⡼ -hϻȤɽ -qɽ\n"
	     "-d ǥХ̾( plughw:0,0 ʤ)\n"
	     "-sɸϤ դե̾\n");
      exit(1);
    }
  }
  //ȥɽ
  if(showMode){
    printf("󥽡륵ɥץ졼䡼 Version 01-2\n");
    printf("(c)2005ǯ116 ͺ\n");
    printf("饤󥹤ϡGNU GPL 2Ǥ\n");
  }
  //̾ΰʤɸϤȤƽ
  if(optind >= argc){
    fp = stdin;
    fileMode = 1;
  }
  
  //ϸɽ(ɸϤξ)
  if(showMode)
    if(fileMode==1)
      printf("ɸϤɤ߹ߤޤ\n");

  //ե򳫤
  if(fileMode==0){
    if((fp=fopen(argv[optind], "rb"))==NULL)
      errorQuit("ե򳫤ޤ");
  }
  
  if(readWaveHeader(fp, sampleStart,
		    frameLength, sCh, sBit, sFreq,
		    fileMode))
    errorQuit("إåɤ߹ߤ˼Ԥޤ");
  frameUnit = sCh * sBit / 8;

  //եɽ
  if(showMode){
    printf("%d ͥ %d Hz %d ӥå\n", sCh, sFreq, sBit);
    printf("%lld ե졼 %.1f \n",
	   frameLength, (double)frameLength / (double)sFreq);
    printf("ǥХ̾: %s\n", pcm.getDeviceName());
  }

  //ǥХ򳫤
  bufSize = pcm.openPlay(sCh, sBit, sFreq, openMode);  
  // debug printf("%lld %d\n",ftello(fp), sampleStart);

  if(bufSize < 8)
    errorQuit("ɥǥХ򳫤ޤǤ");
  
  //ХåեΥ
  if((writeBuf=(char *)malloc(bufSize * frameUnit))==NULL)
    errorQuit("ХåեΥ꤬ݤǤޤǤ");
  
  //ȷǡФ
  framePos = 0;
  endFlag = 0;
  while(!endFlag){
    //ե뤫ɤ߹
    //̤
    if(framePos==0)
      wSize = bufSize;    //ǽϤäѤ
    else
      wSize = (bufSize/8);//ϥХåե1/8礭
    //ɤ߹
    r = fread(writeBuf, frameUnit, wSize, fp);
    //ɾ
    if(r < 0)
      errorQuit("եɤ߽ФɤǤ");
    else if(r == 0)
      break;
    else if(r != wSize)//ɤ᤿礭㤦
      endFlag = 1;     //ǺǸžˤ

    //񤭹̤ι
    wSize = r;
    
    //񤭹ǡ̰ʾˤʤΤԤ
    for(;;){
      freeSpace = pcm.availPCM();
      if(freeSpace >= wSize)
	break;
      else if(freeSpace < 0){
	pcm.prepare();
	ototobi++;
      }
      else
	usleep(1);
    }
    
    //񤭹ߤԤ
    r = pcm.writei(writeBuf, wSize);//ޤ񤯡
    for(pretry=0;pretry<4;pretry++){
      if(r == wSize){
	//˽񤱤ȴ
	break;
      }
      else if(r < 0){
	//Ԥξprepare()ľ
	pcm.prepare();
	r = pcm.writei(writeBuf, wSize);
	ototobi++;
      }
      else if(r < wSize){
	//­ʤϻĤ񤭹
	r2 = pcm.writei(writeBuf+r*frameUnit, wSize-r);
	if(r2 < 0) r =  r2;//顼ξϥ顼ɤ̤
	else       r += r2;//񤱤ϥե졼ɲ
      }
    }
    
    //1ե졼ʾ񤤤ơıǤʤбճ
    if(r>0 && pcm.statePCM() != SND_PCM_STATE_RUNNING)
      pcm.startPCM();
    
    //αհ֤
    if(fileMode){
      //ɸϤʤɤξñ˽񤭹⤦Ȥ礭ä
      framePos += wSize;
    }
    else {
      //̾Υե
      if(r < 0)
	r = 0;
      // debug printf("%lld %d %d\n",framePos, wSize,r);
      framePos += r;//ºݤ˽񤭹᤿ä
      //񤭹ߤ̤Ƚ񤭹᤿̤ۤʤ
      if(r != wSize){
	fseeko(fp, (long long)sampleStart +
	       framePos * frameUnit, SEEK_SET);
	endFlag = 0;//λʤ
      }
    }
  }
  //ΤԤ
  while(pcm.statePCM() == SND_PCM_STATE_RUNNING)
    usleep(1);
  //ǥХĤ
  pcm.closePCM();
  free(writeBuf);
  //եĤ
  if(fileMode==0)
    fclose(fp);
  //λå
  if(showMode){
    if(ototobi)
      printf("%d Ӥޤ \n", ototobi);
    else
      printf("ӤϤޤǤ\n");
    if(framePos != frameLength)
      printf("%lldե졼ޤ\n",framePos);
    else
      printf("ƤΥե졼ޤ\n");
  }
  return 0;
}
