#include "pcmctrl.h"
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <math.h>
#include <unistd.h>
#include <ncurses.h>

//꡼⡼ɤɤ(Х)
int isSCR;

//̾ΰ۾ｪλ
void errorQuit(char *s){
  if(isSCR)
    endwin();
  fprintf(stderr, "顼: %s\n",s);
  exit(1);
}

///ߤϿ֤ɽ
void showTime(long long sec){
  long long h;
  int m,s;
  h = sec / 3600LL;
  m = (sec / 60LL) % 60;
  s = sec % 60;
  mvprintw(5, 0, "Ĺ %lld:%.2d:%.2d    ",h,m,s);
  refresh();
}

///ϿͽĹɽ
void showMaxTime(long long sec){
  long long h;
  int m,s;
  h = sec / 3600LL;
  m = (sec / 60LL) % 60;
  s = sec % 60;
  mvprintw(7, 0, "ͽ %lld:%.2d:%.2d    ",h,m,s);
  refresh();
}

///D:H:M:SÿѴ
long long createHMS(char *s){
  long long k[4]={86400, 3600, 60, 1};
  long long sec = 0;
  int i;
  char *cp;
  int numc = 0;//ϰϤ03
  //':'ο(¤3)
  cp = s;
  for(numc=0;numc<3;cp++,numc++){
    if((cp=strchr(cp,':'))==NULL)
      break;
  }
  //':'ο˽äÿѴ
  cp = s;
  for(i=0;i<=numc;i++){
    sec += k[3-numc+i] * atoll(cp);
    if(i<numc)
      cp = strchr(cp, ':') + 1;
  }
  return sec;
}

///Ӥβɽ
void showOtotobi(int i){
  mvprintw(6,0,"Ӥ %d ȯƤޤ", i);
  refresh();
}

// ˳Ƥեˤإå񤯡ᤷǸƤ֤
// 0ｪλʳ()ϰ۾
int writeWaveHeader(FILE *fp, int sStart,
		    long long fLength,
		    int sCh, int sBit, int sFreq){
  long long ltmp;
  unsigned int ui;
  unsigned short us;
  char ch0 = 0x00;
  int i, b;
  int fUnit = sCh * sBit / 8; //1ե졼ΥХȿ
  
  //ޤ"RIFF"
  if(fwrite("RIFF",4,1,fp)!=1)
    return -2;
  
  //ϤΥХȿ
  ltmp =  (sStart - 8) + (fLength * fUnit);
  if(ltmp > 4294967295LL)//32ӥåȤɽǽͤˤ
    ltmp = 4294967295LL;
  ui = ltmp;
  if(fwrite(&ui,4,1,fp)!=1)
    return -3;
  
  //ʸ8
  if(fwrite("WAVEfmt ",8,1,fp)!=1)
    return -4;
  
  //chunkĹ
  ui = sStart - 28;
  if(fwrite(&ui,4,1,fp)!=1)
    return -5;

  //PCMɤ
  us = 1;
  if(fwrite(&us,2,1,fp)!=1)
    return -6;
  
  //ϥͥ
  us = sCh;
  if(fwrite(&us,2,1,fp)!=1)
    return -7;
  
  //ϼȿ
  ui = sFreq;
  if(fwrite(&ui,4,1,fp)!=1)
    return -8;
  
  //1äΥХȿ
  ui = fUnit * sFreq;
  if(fwrite(&ui,4,1,fp)!=1)
    return -9;
  
  //1ե졼ढΥХȿ
  us = fUnit;
  if(fwrite(&us,2,1,fp)!=1)
    return -10;
  
  //̻Ҳӥåȿ
  us = sBit;
  if(fwrite(&us,2,1,fp)!=1)
    return -11;
  
  // chunk;äƤ̤0x00񤭽Ф
  b = sStart - 44;
  for(i=0;i<b;i++){
    if(fwrite(&ch0,1,1,fp)!=1)
      return -12;
  }
  
  //"data"
  if(fwrite("data",4,1,fp)!=1)
    return -13;
  
  //ȷΥХȿ
  ltmp = fLength * fUnit;
  if(ltmp > 4294967295LL)//32ӥåȤɽǽͤˤ
    ltmp = 4294967295LL;
  ui = ltmp;
  if(fwrite(&ui,4,1,fp)!=1)
    return -14;
  
  //˽񤭹߽λ
  fflush(fp);
  return 0;
}

int main(int argc, char *argv[]){
  FILE *fp;                        //Υե
  PcmCTRL pcm;  //ǥХ򰷤饹
  char *pcmBuf; //ϿǡХåե
  int bufSize = 0;           //ХåեΥե졼
  int openMode = SND_PCM_NONBLOCK; //ǥեȤϥΥ֥å⡼
  long long frameLength    = 0;//ߤΥե졼ñ̤ǤĹ
  long long secLength      = 0;//ߤñ̤ǤĹ
  long long maxFrameLength = 0;//ǽʺĹ
  long long maxByteLength  = 9223372036854775807LL - 65536LL;//ȷΤκĹХȿ
  long long maxSecLength   = 0;//ǻ꤬Фÿޤ
  int frameUnit = 0;           //1ե졼ΥХȿ
  int showMode  = 1;           //ɽ 0:ɽʤ 1:ɽ
  int captureUnit;             //FIFOˤΥե졼ʾ夿ޤä
  /* Ͽʼ */
  int freq = 44100;
  int ch   = 2;
  int widthbit = 16;
  /*  */
  int ototobi = 0;//Ӥ
  int optr;     //ޥɥ饤󥪥ץ
  int keyChar = 0;//ܡɤ
  int readyFrame = 0;//ɤ߹߲ǽʥե졼
  int goOut = 0;//Ͽ򽪤ꤿ0ʳˤ

  //꡼⡼ɤǤϤʤ
  isSCR = 0;

  //ץɤ߹
  while((optr=getopt(argc, argv, "bqhf:c:w:l:d:"))!=-1){
    switch(optr){
    case 'b'://֥å⡼
      openMode = 0;//֥å⡼ɤ
      break;
    case 'q'://ɽʤ⡼(ϿϿˤʤޤ)
      showMode = 0;
      break;
    case 'f'://ȿ
      if(optarg==NULL)
	errorQuit("ȿͤĤޤ");
      freq = atoi(optarg);
      break;
    case 'c'://ͥ(1ޤ2)
      if(optarg==NULL)
	errorQuit("ͥͤĤޤ");
      ch = atoi(optarg);
      break;
    case 'w'://̻Ҳӥåȿ
      if(optarg==NULL)
	errorQuit("̻ҲӥåȿͤĤޤ");
      widthbit = atoi(optarg);
      break;
    case 'l'://ñ̤ǤĹ
      if(optarg==NULL)
	errorQuit("ÿλ꤬Ĥޤ");
      maxSecLength = createHMS(optarg);
      break;
    case 'd'://ǥХ̾
      if(optarg==NULL)
	errorQuit("ǥХ̾Ĥޤ");
      pcm.setDeviceName(optarg);
      break;
    case 'h'://إפɽƽλ
    case '?':
      printf("Ȥ:\n-hϤإ -bϥ֥å⡼ -qɽ\n"
	     "-l » -c ͥ -w ̻Ҳӥåȿ -f ȿ\n"
	     "-d ǥХ̾( plughw:0,0 ʤ)\n"
	     "Ͽե̾\n");
      exit(1);
    }
  }
  
  //Ĺξ¤(ºݤˤmaxFrameLengthȤ)
  frameUnit = ch * widthbit / 8;
  maxFrameLength = maxByteLength / frameUnit;
  //ÿΤۤûϤ¤˺Ѥ
  if(maxSecLength > 0)
    if(maxSecLength * freq < maxFrameLength)
      maxFrameLength = maxSecLength * freq;
  
  //ե򳫤
  if(optind >= argc)
    errorQuit("ե̾ꤵƤޤ");
  if((fp=fopen(argv[optind],"wb"))==NULL)
    errorQuit("ե򳫤ޤǤ");
  if(writeWaveHeader(fp, 46, maxFrameLength,
		     ch, widthbit, freq))
    errorQuit("إå񤭹ޤǤ");
  
  //ǥХ򳫤
  if((bufSize = pcm.openRecord(ch, widthbit, freq, openMode)) < 16)
    errorQuit("ǥХ򳫤ޤǤ");
  if((pcmBuf = (char *)malloc(bufSize * frameUnit))==NULL)
    errorQuit("ХåեݤǤޤǤ");
  
  //̤򹹿ƥꥢ륿ʥ󥽡˰ܹԤ
  if(showMode){
    initscr();
    cbreak();
    noecho();
    nonl();
    keypad(stdscr, TRUE);
    timeout(0);
    isSCR = 1;//꡼⡼
  }
  //ȥʤɤɽ
  if(showMode){
    mvprintw(0,0,"󥽡륵ɥ쥳 Version 01-2");
    mvprintw(1,0,"(c)2005ǯ116 ͺ 饤󥹤GNU GPL 2Ǥ");
    mvprintw(2,0,"%d ͥ %d ӥå %d Hz Хåե %d Х",
	     ch, widthbit, freq, bufSize * frameUnit);
    mvprintw(3,0,"ǥХ̾: %s",
	     pcm.getDeviceName());    
    //ɬפ˱ϿͽĹɽ
    if(maxSecLength>0)
      showMaxTime(maxFrameLength / (long long)freq);
    refresh();
  }
  //ѥ᡼ν
  secLength = -1; //ϻɽ뤿ν
  frameLength = 0;//Ͽǡθߤ礭
  // FIFO1/16ʾ夿ޤäФ
  captureUnit = bufSize / 16;
  if(captureUnit < 1)
    captureUnit = 1;
  if(showMode){
    mvprintw(4,0,"Ͽ档ߤˤϥڡ򲡤Ƥ");
    refresh();
  }
  if(pcm.startPCM() < 0)
    errorQuit("Ͽ򳫻ϤǤޤ");

  //ϿΥ롼
  while(frameLength < maxFrameLength && !goOut){

    //FIFOХåե˽ʬޤޤԤ
    for(;;){
      readyFrame = pcm.availPCM();
      if(readyFrame >= captureUnit ||
	 readyFrame >= (maxFrameLength - frameLength))
	break;
      else if(readyFrame < 0){      
	//ȯꥫХư򤹤
	ototobi++;
	if(showMode)
	  showOtotobi(ototobi);
	pcm.prepare();
	pcm.startPCM();
      }
      else {
	//ڡ줿鼡Ǹˤ
	if(showMode){
	  keyChar = getch();
	  if(keyChar == ' ')
	    goOut = 1;
	}
	//Ͽв֤ɽ
	if(frameLength / freq != secLength){
	  secLength = frameLength / freq;
	  if(showMode)
	    showTime(secLength);
	}
	//Ҥȵ٤
	usleep(1);
      }
    }
    
    //ºݤɤ߹礭
    if(readyFrame > bufSize)
      readyFrame = bufSize; //¤bufSizeĤΥե졼
    //ĹĶĹĹ˹礦褦˽̤
    if(readyFrame > (maxFrameLength - frameLength))
      readyFrame = maxFrameLength - frameLength;
    
    //ɥɤɤ߹
    readyFrame = pcm.readi(pcmBuf, readyFrame);
    
    if(readyFrame > 0){
      //եؽ񤭹
      if(fwrite(pcmBuf, frameUnit, readyFrame, fp) != readyFrame)
	errorQuit("ǡν񤭤ߤ˼Ԥޤ");
      frameLength += readyFrame;      
    }else{
      //ȯꥫХư
      pcm.prepare();
      pcm.startPCM();
      ototobi++;
      if(showMode)
	showOtotobi(ototobi);
    }
  }
  //إå򹹿ƥեĤ
  fseeko(fp, 0, SEEK_SET);//Ƭ˴᤹
  if(writeWaveHeader(fp, 46, frameLength,
		     ch, widthbit, freq))
    errorQuit("إå񤭴ޤǤ");
  fclose(fp);
  //ǥХĤ
  pcm.closePCM();
  //꡼βʤ
  free(pcmBuf);
  //λ
  if(showMode){
    endwin();
    isSCR = 0;//꡼⡼ɤȴ
  }
  if(showMode){
    printf("%.1lfϿޤ\n",
	   (double)frameLength / (double)freq);    
    if(ototobi>0)
      printf("λ%d Ӥޤ\n", ototobi);
    else
      printf("ｪλ\n");
  }
  return 0;
}
