#include "pcmctrl.h"

PcmCTRL::PcmCTRL(){
  //ѿν
  length = 0;
  //ǥХ̾
  deviceName = NULL;
  setDeviceName("plughw:0,0");
}

PcmCTRL::~PcmCTRL(){
  //ǥХ̾Υ
  delete [] deviceName;
}

int PcmCTRL::openPlay(int ch, int bit, int freq, int openMode){
  return openDevice(ch, bit, freq, 0, openMode);//ꤲ
}
int PcmCTRL::openRecord(int ch, int bit, int freq, int openMode){
  return openDevice(ch, bit, freq, 1, openMode);//ꤲ
}
int PcmCTRL::openDevice(int ch, int bit, int freq, int isRecord, int openMode){
  unsigned int rfreq;
  snd_pcm_uframes_t reqBufSize = 1024*1024;//ХåեΥե졼׵
  snd_pcm_uframes_t periodSize = 1;//ǤĤǤǤȤ褤
  int dir = 0;           //
  int bufSize = 0;
  
  //
  hwparams = NULL;
  swparams = NULL;
  output = NULL;
  length = 0;
  snd_pcm_hw_params_malloc(&hwparams); 
  if(hwparams==NULL)
    return -301;
  snd_pcm_sw_params_malloc(&swparams);
  if(swparams == NULL)
    return -302;
  if(snd_output_stdio_attach(&output, stdout, 0)<0)
    return -303;
  
  //եޥåȤ
  if(bit == 8)
    format = SND_PCM_FORMAT_U8; //8bit -> unsigned char
  else if(bit==16)
    format = SND_PCM_FORMAT_S16_LE ;//16bit -> signed short
  else
    return -101;
  
  //ϡɥ򳫤
  switch(isRecord){
  case 0:
    if(snd_pcm_open(&handle, deviceName,
		    SND_PCM_STREAM_PLAYBACK, openMode) < 0)
      return -1;
    break;
  case 1:
    if(snd_pcm_open(&handle, deviceName,
		    SND_PCM_STREAM_CAPTURE, openMode) < 0)
      return -1;
    break;
  default:
    return -1;
  }
  
  //ϡɥѥ᡼
  if(snd_pcm_hw_params_any(handle, hwparams)<0){
    closePCM();
    return -2;
  }
  if(snd_pcm_hw_params_set_access(handle, hwparams,
				  SND_PCM_ACCESS_RW_INTERLEAVED)<0){
    closePCM();
    return -3;
  }
  if(snd_pcm_hw_params_set_format(handle, hwparams, format)<0){
    closePCM();
    return -4;
  }
  if(snd_pcm_hw_params_set_channels(handle, hwparams, ch)<0){
    closePCM();
    return -5;
  }
  rfreq = freq;
  if(snd_pcm_hw_params_set_rate_near(handle, hwparams, &rfreq, &dir)<0){
    closePCM();
    return -6;
  }
  if(snd_pcm_hw_params_set_buffer_size_near(handle, hwparams, &reqBufSize)<0){
    closePCM();
    return -7;
  }
  if(snd_pcm_hw_params_set_period_size_near(handle, hwparams,
					    &periodSize, &dir) < 0){
    closePCM();
    return -8;
  }
  if(snd_pcm_hw_params(handle, hwparams)<0){
    closePCM();
    return -9;
  }
  //ХåեäѤˤʤȼư: ưȤʻ롣
  if(snd_pcm_sw_params_current(handle, swparams)<0){
    closePCM();
    return -201;
  }
  if(snd_pcm_sw_params_set_start_threshold(handle, swparams, reqBufSize)<0){
    closePCM();
    return -202;
  }
  if(snd_pcm_sw_params(handle, swparams)<0){
    closePCM();
    return -203;
  }
  //prepareƽ񤭹ߤ
  if(snd_pcm_prepare(handle)<0){
    closePCM();
    return -10;
  }
  switch(isRecord){
  case 0://⡼
    //ǲǽʶ̤ºݤν񤭹߲ǽʥХåե
    if((bufSize = snd_pcm_avail_update(handle))<0){
      closePCM();
      return -11;
    }
    break;
  case 1://Ͽ⡼
    if((bufSize=reqBufSize)<0){
      closePCM();
      return -11;
    }
    break;
  }
  
  //Хåե(ñ̤ϥե졼)֤
  length = (bufSize>=0) ? bufSize : 0;//ѿˤХåեݴ
  return bufSize;
}

int PcmCTRL::prepare(){
  return snd_pcm_prepare(handle);
}
int PcmCTRL::availPCM(){
  return (int)snd_pcm_avail_update(handle);
}
int PcmCTRL::writei(const void *b, unsigned int s){
  return (int)snd_pcm_writei(handle, b, s);
}
int PcmCTRL::readi(void *b, unsigned int s){
  return (int)snd_pcm_readi(handle, b, s);
}
int PcmCTRL::statePCM(){
  return snd_pcm_state(handle);
}
int PcmCTRL::startPCM(){
  return snd_pcm_start(handle);
}
int PcmCTRL::closePCM(){
  //β
  if(hwparams != NULL)
    snd_pcm_hw_params_free(hwparams);
  if(swparams != NULL)
    snd_pcm_sw_params_free(swparams);  
  
  //ǥХĤ
  return snd_pcm_close(handle);
}

int PcmCTRL::dropPCM(){
  return snd_pcm_drop(handle);
}

void PcmCTRL::setDeviceName(char *s){
  int len;
  if(s != NULL){
    if((len = strlen(s)) > 0){
      if(deviceName != NULL)
	delete [] deviceName;

      deviceName = new char [len+1];
      if(deviceName == NULL){
	fprintf(stderr, "꤬­ޤ\n");
	exit(1);
      }
      strcpy(deviceName, s);
    }
  }
}

char * PcmCTRL::getDeviceName(){
  return deviceName;
}
